GNU bug report logs - #13920
link_all_deps and indirect dependencies

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: libtool; Reported by: Дилян Палаузов <dilyan.palauzov@HIDDEN>; dated Sun, 10 Mar 2013 22:12:01 UTC; Maintainer for libtool is bug-libtool@HIDDEN.

Message received at 13920 <at> debbugs.gnu.org:


Received: (at 13920) by debbugs.gnu.org; 2 Apr 2013 20:07:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Apr 02 16:07:24 2013
Received: from localhost ([127.0.0.1]:58634 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1UN7UJ-0004oe-Gz
	for submit <at> debbugs.gnu.org; Tue, 02 Apr 2013 16:07:24 -0400
Received: from [94.23.222.218] (port=51794 helo=serveur.turbivo.com)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <dilyan.palauzov@HIDDEN>) id 1UN7UF-0004oN-F6
	for 13920 <at> debbugs.gnu.org; Tue, 02 Apr 2013 16:07:21 -0400
Received: from aegeepc1.aegee.uni-karlsruhe.de ([129.13.131.81]
	helo=smtp.aegee.org)
	by serveur.turbivo.com with esmtpsa (TLS1.0:RSA_ARCFOUR_SHA1:128)
	(Exim 4.80) (envelope-from <dilyan.palauzov@HIDDEN>)
	id 1UN7RE-0006IM-U0; Tue, 02 Apr 2013 22:04:12 +0200
Authentication-Results: aegeeserv.aegee.org;
	auth=pass (PLAIN) smtp.auth=didopalauzov
DKIM-Filter: OpenDKIM Filter v2.8.1 smtp.aegee.org r32K4C47023712
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=aegee.org; s=k4096;
	t=1364933053; i=dkim+MSA-ssl@HIDDEN;
	bh=gE7zCxX+sx+V4ULPDG+Jg6jLun2VHlY5M0getE8+BbM=;
	h=Date:From:To:Subject;
	b=jKdxEwuvUPFWTrCMGhdjgdLiVn5cqjE3inzpWjIYuq8pVSDZZp9+GQDo/xOzhHReP
	Ejw9G5Tc5q9XoRAev/VSMMaT+bARf0hb8dCGi+H95aWrOS2StNLak5JUNiG5dxSQLl
	dPWJTh39dr4qQXQZpYo1wv5qei+L8tl3AefPy3Gn79ozPSpKksPMzaroQx4egPkWje
	EnN59+Gz8eLvc2FPjlcHCCfyX9bifXbuVjRJg7mVWLzb0jJOOSWxjqIz3XoVc7eb2Z
	/erSstmyrHx3/D8KlBk2GmWgCKuf0J1cHHDsM/Fby5+eAyXwFI6IOIFNFl28KKqdFt
	kdS7rcfeeu36d3kVksYKM4iGrNPB882eCdcXW82J+VwZoZNR3Wz/8c3JP3/E04Y0zI
	hxfVal2zTxMp+AscAwpaOSruqBPxdCmKknL2DVQ5ilMdjR57VBhbHKoI0GFaSOitGV
	/215uqJg+KuebLICJFAQGs5Pds9Hs+1NZ2atNC1GW7u4IDOtKMs615Tk2FPX4oCTyB
	0QMUCE+/aLcKuag/tviOCcQN8ejPyM4M7xPwwAU5jWLtq4OOnB+uckCaD5VGev5Mkg
	cxnc2fVk0gIPS175Anydcx1+eVoAsD8cXSCSbf923+zwSdi6KM6Fdwqxl6Rz1HU+TZ
	plx+TwbW0XW3MGOee/OetZ68=
Received: from [192.168.0.6] (port-212-202-110-243.static.qsc.de
	[212.202.110.243]) (authenticated bits=0)
	by smtp.aegee.org (8.14.6/8.14.5) with ESMTP id r32K4C47023712
	(version=TLSv1/SSLv3 cipher=DHE-RSA-CAMELLIA256-SHA bits=256 verify=NO);
	Tue, 2 Apr 2013 20:04:13 GMT
Message-ID: <515B39B9.7030701@HIDDEN>
Date: Tue, 02 Apr 2013 22:04:09 +0200
From: =?UTF-8?B?0JTQuNC70Y/QvSDQn9Cw0LvQsNGD0LfQvtCy?=
	<dilyan.palauzov@HIDDEN>
User-Agent: Mozilla/5.0 (Windows NT 6.1; WOW64;
	rv:17.0) Gecko/20130307 Thunderbird/17.0.4
MIME-Version: 1.0
To: 13920 <at> debbugs.gnu.org, 702737@HIDDEN
Subject: documentning link_all_deplibs on Debian
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: 7bit
X-Virus-Scanned: clamav-milter 0.97.7 at aegeeserv
X-Virus-Status: Clean
X-DKIM-Status: pass [(aegee.org) - 129.13.131.81]
X-DKIM-Status: pass [(dkim+MSA-ssl@HIDDEN) - 129.13.131.81]
X-Spam-Score: 1.6 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview:  Hello,
	In regards of libtool bug #13920 and debian bug #702737
	I kindly ask you to update the documentation of libtool in aspect of
	link_all_deplibs, 
	with something like the text below. I consider this as essential,
	as it would
	have saved me quite some (from my free) time investigating why the
	linking
	on Debian works differently/not according to the documentation. A
	proper documentation of link_all_deplibs on different systems,
	will safe the time
	of other developers investigating the same issue. [...] 
	Content analysis details:   (1.6 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.5000]
	0.8 RDNS_NONE Delivered to internal network by a host with no rDNS
	0.0 T_DKIM_INVALID DKIM-Signature header exists but is not valid
X-Debbugs-Envelope-To: 13920
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 1.6 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hello, In regards of libtool bug #13920 and debian bug #702737
    I kindly ask you to update the documentation of libtool in aspect of link_all_deplibs,
    with something like the text below. I consider this as essential, as it would
    have saved me quite some (from my free) time investigating why the linking
    on Debian works differently/not according to the documentation. A proper
   documentation of link_all_deplibs on different systems, will safe the time
    of other developers investigating the same issue. [...] 
 
 Content analysis details:   (1.6 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.4916]
  0.8 RDNS_NONE              Delivered to internal network by a host with no rDNS
  0.0 T_DKIM_INVALID         DKIM-Signature header exists but is not valid

Hello,

In regards of libtool bug #13920 and debian bug #702737 I kindly ask you 
to update the documentation of libtool in aspect of link_all_deplibs, 
with something like the text below.  I consider this as essential, as it 
would have saved me quite some (from my free) time investigating why the 
linking on Debian works differently/not according to the documentation. 
  A proper documentation of link_all_deplibs on different systems, will 
safe the time of other developers investigating the same issue.

diff --git a/doc/libtool.texi b/doc/libtool.texi
index c06ddaa..ec0d926 100644
--- a/doc/libtool.texi
+++ b/doc/libtool.texi
@@ -6938,6 +6938,9 @@ the file name that the linker finds when given 
@option{-l@var{name}}.
  Whether libtool must link a program against all its dependency libraries.
  Set to @samp{yes} or @samp{no}.  Default is @samp{unknown}, which is
  a synonym for @samp{yes}.
+
+On Debian and Ubuntu systems the default is @samp{no}.  As a side effect,
+transitive dependencies which rely on @samp{yes} will break.
  @end defvar

  @defvar link_static_flag




Information forwarded to bug-libtool@HIDDEN:
bug#13920; Package libtool. Full text available.

Message received at 13920 <at> debbugs.gnu.org:


Received: (at 13920) by debbugs.gnu.org; 11 Mar 2013 05:35:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Mar 11 01:35:47 2013
Received: from localhost ([127.0.0.1]:45083 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1UEvOk-0002Vo-N2
	for submit <at> debbugs.gnu.org; Mon, 11 Mar 2013 01:35:47 -0400
Received: from caiajhbdccac.dreamhost.com ([208.97.132.202]:49118
	helo=homiemail-a15.g.dreamhost.com)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <gary@HIDDEN>) id 1UEvOg-0002Vc-5k
	for 13920 <at> debbugs.gnu.org; Mon, 11 Mar 2013 01:35:44 -0400
Received: from homiemail-a15.g.dreamhost.com (localhost [127.0.0.1])
	by homiemail-a15.g.dreamhost.com (Postfix) with ESMTP id BC5C176C069;
	Sun, 10 Mar 2013 22:34:48 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=vaughan.pe; h=content-type
	:mime-version:subject:from:in-reply-to:date:cc
	:content-transfer-encoding:message-id:references:to; s=
	vaughan.pe; bh=eLtzo00ddv+XxnlpgM3ZWelxEQY=; b=Z69FkbUwnXTRVx4bF
	CShwKshiyuzgPc9cIaoRfpVuZHCXg6v8Qu5Vv7ddGUM1BLP046/Y3FB+lvuEouys
	Kg0r/jt1zskflm2LQ1ssEecf2oiCx+R9ANkK4q3LBVSlVI6RQaCOXOua9OHMnAyS
	AZdHvJkCW0xsPHe9sGS3xxgwPg=
Received: from [192.168.1.3] (unknown [14.207.9.186])
	(using TLSv1 with cipher AES128-SHA (128/128 bits))
	(No client certificate requested)
	(Authenticated sender: gary@HIDDEN)
	by homiemail-a15.g.dreamhost.com (Postfix) with ESMTPSA id 4C2C576C06E; 
	Sun, 10 Mar 2013 22:34:46 -0700 (PDT)
Content-Type: text/plain; charset=utf-8
Mime-Version: 1.0 (Mac OS X Mail 6.2 \(1499\))
Subject: Re: bug#13920: link_all_deps and indirect dependencies
From: "Gary V. Vaughan" <gary@HIDDEN>
In-Reply-To: <513D04C7.6050000@HIDDEN>
Date: Mon, 11 Mar 2013 12:34:42 +0700
Content-Transfer-Encoding: quoted-printable
Message-Id: <86623B0A-74D0-4977-8F1A-74335E85AB04@HIDDEN>
References: <513D04C7.6050000@HIDDEN>
To: =?utf-8?B?0JTQuNC70Y/QvSDQn9Cw0LvQsNGD0LfQvtCy?=
	<dilyan.palauzov@HIDDEN>
X-Mailer: Apple Mail (2.1499)
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 13920
Cc: 13920 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.9 (-)

On 11 Mar 2013, at 05:10, =D0=94=D0=B8=D0=BB=D1=8F=D0=BD =
=D0=9F=D0=B0=D0=BB=D0=B0=D1=83=D0=B7=D0=BE=D0=B2 =
<dilyan.palauzov@HIDDEN> wrote:
> Hello,

Hi,

> in my project, I have program A that dynamically links with library B =
(library B is mentioned as DT_NEEDED in program A), and library B =
dynamically links with library C (library C is mentioned as DT_NEEDED in =
library B, and under dependency_libs in libraryB.la).
>=20
> --> If I want to use a function from library C in program A, am I =
supposed to list (in Makefile.am) that program A depends on library C, =
or can I rely on the fact, that program A loads library B and library B =
loads library C, thus it is not necessary to link explicitly program A =
with library C?

Best practice dictates that you should list all of the libraries whose =
APIs you use.  So if you use an API from C in A, then A has an explicit =
dependency on C.

Libtool doesn't enforce this though, so if you prefer to be sloppy about =
dependencies it will still link correctly.


> Under Debian, libtool is patched to have link_all_deplibs=3Dno, on =
other systems link_all_deplibs is unknown/yes.  When link_all_deplibs is =
yes, I do not have to link program A explicitly with library C; when =
link_all_deplibs is no, I have to link explicitly.

Debian have broken one of the core features of libtool with that patch.  =
If you prefer to use the debian libtool, then you will need to list all =
your deplibs explicitly, since they have turned off the feature that =
tracks them for you. Alternatively, you can install a fully working =
libtool from gnu.org.

Debian and GNU disagree about the benefits of link_all_deplibs, and we =
have agreed to disagree.  There's no need to dig up the old arguments =
about the relative benefits of either approach, where both sides are =
already happy to co-exist peacefully :)

> Program A, library B and library C are in the control of the same =
person, so the dependency on libC in libB is ensured.
>=20
> According to the Debian maintainer of the libtool package, =
bugs.debian.org/cgi-bin/bugreport.cgi?bug=3D702737 , libtool's =
documentation shall state (or states, but I don't find where), that =
program A must explicitly link with library C.

Agreed.

Cheers,
--=20
Gary V. Vaughan (gary AT gnu DOT org)





Information forwarded to bug-libtool@HIDDEN:
bug#13920; Package libtool. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 10 Mar 2013 22:11:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Mar 10 18:11:54 2013
Received: from localhost ([127.0.0.1]:44616 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1UEoTA-0008B9-Sb
	for submit <at> debbugs.gnu.org; Sun, 10 Mar 2013 18:11:54 -0400
Received: from eggs.gnu.org ([208.118.235.92]:37925)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <dilyan.palauzov@HIDDEN>) id 1UEoT8-0008Au-EJ
	for submit <at> debbugs.gnu.org; Sun, 10 Mar 2013 18:11:51 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <dilyan.palauzov@HIDDEN>) id 1UEoSB-0005xn-Ns
	for submit <at> debbugs.gnu.org; Sun, 10 Mar 2013 18:10:54 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.5 required=5.0 tests=BAYES_00, RCVD_IN_DNSWL_NONE, 
	RCVD_IN_XBL,T_DKIM_INVALID autolearn=no version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:38124)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <dilyan.palauzov@HIDDEN>) id 1UEoSB-0005xV-Jz
	for submit <at> debbugs.gnu.org; Sun, 10 Mar 2013 18:10:51 -0400
Received: from eggs.gnu.org ([208.118.235.92]:49284)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <dilyan.palauzov@HIDDEN>) id 1UEoS9-0005h4-6W
	for bug-libtool@HIDDEN; Sun, 10 Mar 2013 18:10:51 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <dilyan.palauzov@HIDDEN>) id 1UEoS6-0005wc-Cj
	for bug-libtool@HIDDEN; Sun, 10 Mar 2013 18:10:48 -0400
Received: from mailout-aegee.scc.kit.edu ([129.13.185.235]:56716)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <dilyan.palauzov@HIDDEN>) id 1UEoS6-0005r6-2e
	for bug-libtool@HIDDEN; Sun, 10 Mar 2013 18:10:46 -0400
Received: from smtp.aegee.org (aegeeserv.aegee.uni-karlsruhe.de
	[129.13.131.80])
	by scc-mailout-02.scc.kit.edu with esmtp (Exim 4.72 #1)
	id 1UEoRi-0008Fl-5G; Sun, 10 Mar 2013 23:10:22 +0100
Authentication-Results: aegeeserv.aegee.org;
	auth=pass (PLAIN) smtp.auth=didopalauzov
DKIM-Filter: OpenDKIM Filter v2.8.0 smtp.aegee.org r2AMAL1D021179
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=aegee.org; s=k4096;
	t=1362953423; i=dkim+MSA-ssl@HIDDEN;
	bh=TUlkxHJZc3A4xc8Ufsj/ClK45Aep7wlkaKHTsuxWs4w=;
	h=Date:From:To:Subject;
	b=jIOUZg0EZkhPp89HRPaxBWV01erFvyUtSr5nxNwhBHunt9CmTmMymhkDtlXUf6Pe2
	42XnHADSYTkLmd0WY8pcxpZcSysW4aiLPlumHTTwb6vkfXvsg8mfGtr0hb7ix0FBs2
	R9o5FX/z9NQloSHZLgPUayKvtcR1bn3twRtNwjby5V3NBAHjK2uFAnujjJfJTkvvur
	W+Mq4QCKbWkuvcfhfxrIB6VNbC1JcDgTJAzT2fL4/+xxn1K92jhEdbVEPWBUXReNqf
	OyQd6PJ7nXWUOo+HE5JkkzlcE1iR6Hvn2PD7HiWeZ4YbVo3UlDjCUYhXzSbZzyffR9
	ua38NjUnF79x8V3nHdxwcBKeP+x9ZofGguLn9XbsfDMrcqT05EnlXk7oy8RCI0XCOn
	VLkTLE0Jq+NGAI+PW5KLQCwAbhjHj15IyX1brvs7TdVV135gxJ29ZvWd1CDb+ryTxI
	NmIeyqS5BLGBbKgxJ/03x2otNXyCGuaCnaZokJE95VA+uWHxQI1YYZ7pYH3sGLzhyp
	PbW0N2Bgwlj89b7WIVs9ozr+pktaAsUA7S/6oFFb2n/I9iwSVfrBU0pOkzpTwx32Sw
	toypw1hbf8/uf7tG1L6RDoQ3l1sIvskBR3GRFM0nT8H1w8TqTFfAbaTSl9KxuqVJap
	wMQS3kWH+fL2rxYzmfXR4joA=
Received: from [10.21.210.76] (nat-gw1.rrze.uni-erlangen.de [192.44.85.23])
	(authenticated bits=0)
	by smtp.aegee.org (8.14.6/8.14.5) with ESMTP id r2AMAL1D021179
	(version=TLSv1/SSLv3 cipher=DHE-RSA-CAMELLIA256-SHA bits=256 verify=NO)
	for <bug-libtool@HIDDEN>; Sun, 10 Mar 2013 22:10:23 GMT
Message-ID: <513D04C7.6050000@HIDDEN>
Date: Sun, 10 Mar 2013 23:10:15 +0100
From: =?UTF-8?B?0JTQuNC70Y/QvSDQn9Cw0LvQsNGD0LfQvtCy?=
	<dilyan.palauzov@HIDDEN>
User-Agent: Mozilla/5.0 (Windows NT 6.1; WOW64;
	rv:17.0) Gecko/20130215 Thunderbird/17.0.3
MIME-Version: 1.0
To: bug-libtool@HIDDEN
Subject: link_all_deps and indirect dependencies
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: 8bit
X-Virus-Scanned: clamav-milter 0.97.5 at aegeeserv
X-Virus-Status: Clean
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 208.118.235.17
X-Spam-Score: -4.2 (----)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -6.9 (------)

Hello,

in my project, I have program A that dynamically links with library B 
(library B is mentioned as DT_NEEDED in program A), and library B 
dynamically links with library C (library C is mentioned as DT_NEEDED in 
library B, and under dependency_libs in libraryB.la).

--> If I want to use a function from library C in program A, am I 
supposed to list (in Makefile.am) that program A depends on library C, 
or can I rely on the fact, that program A loads library B and library B 
loads library C, thus it is not necessary to link explicitly program A 
with library C?

Under Debian, libtool is patched to have link_all_deplibs=no, on other 
systems link_all_deplibs is unknown/yes.  When link_all_deplibs is yes, 
I do not have to link program A explicitly with library C; when 
link_all_deplibs is no, I have to link explicitly.

Program A, library B and library C are in the control of the same 
person, so the dependency on libC in libB is ensured.

According to the Debian maintainer of the libtool package, 
bugs.debian.org/cgi-bin/bugreport.cgi?bug=702737 , libtool's 
documentation shall state (or states, but I don't find where), that 
program A must explicitly link with library C.

Thanks in advance for your feedback
   Дилян




Acknowledgement sent to Дилян Палаузов <dilyan.palauzov@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-libtool@HIDDEN. Full text available.
Report forwarded to bug-libtool@HIDDEN:
bug#13920; Package libtool. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.